program freeE 
! free energy of magnetic system F, M= dF/dB, chi=d2F/dB2
! dependence of susceptibility and magnetic moment on magnetic field 
! for nt selected temperatures
! step dB of B must be small enough to allow derivative dF/dB 
! February 12. 2016. 
implicit real*8(a-h,o-z)
REAL*8,ALLOCATABLE  :: magt(:),chit(:),ft(:)
REAL*8,ALLOCATABLE  :: e(:,:),f(:),g(:,:),chi(:,:),mag(:),temp(:)
read(5,*)nstates,nt,nb,b0,db
write(6,*)

cf1=17.276         ! E[meV] / mu_B
cft=0.08616        ! K -> meV
cfchi=0.5585       ! mu_B/T -> emu/mol
allocate (e(nstates,nb),f(nb),magt(nb),chit(nb),temp(nt))
read(5,*)(temp(it),it=1,nt)
do istates=1,nstates   
 do ib=1,nb
  read(9,*)b,emev             ! B in T, e im meV, output of bhelp
  e(istates,ib)=emev/cft ! energy in K, must be nonnegative
 enddo
enddo

write(6,*)
do it=1,nt       ! loop over temperature
 t=temp(it)
 write(6,204)t
 204 format(' Temperature =',f7.1,' K')
 do ib=1,nb
  z=0.               ! sum of states
  do istates = 1,nstates
   pop=exp(-e(istates,ib)/t)
   z=z+pop
   y=-cft*t*dlog(z)
  enddo
  f(ib)=-cft*t*dlog(z)   ! free energy
 enddo
 do ib=2,nb-1            
  d1f=(f(ib+1)-f(ib-1))/(2.*db)  ! first derivative of f
  magt(ib)=cf1*d1f               ! moment in mu_B
 enddo
 do ib=3,nb-2            
  d1m=(magt(ib+1)-magt(ib-1))/(2.*db)  ! derivative of moment
  chit(ib)=cfchi*d1m             ! chi in emu/mol 
 enddo                                     
 b=b0
 write(6,*) &
 '   B [T]     F [meV]        m [mu_B]    chi [emu/mol]     T [K]'
 do ib=1,nb
  if((ib.gt.2).and.(ib.lt.nb-1))then
   write(6,100)b,f(ib),magt(ib),chit(ib),t
   write(23,100)b,f(ib),magt(ib),chit(ib),t
  endif
 b=b+db
 enddo
enddo
100 format(f9.4,3f14.5,6x,f7.2)
stop
end
