program regr
implicit real*8(a-h,o-z)
! polynomial regression
! present version is for quadratic regression  n=3
! e is function of be given in nbe points.
! nstate different e may be treated simultaneously 
real*8,ALLOCATABLE     :: e(:,:),be(:),b(:),a(:,:),a1(:,:,:)
real*8,ALLOCATABLE     :: xregr(:,:),g(:,:),vv(:,:),sigsquare(:)
real*8,ALLOCATABLE     :: alphag(:),alphav(:),gt(:,:),vt(:,:),e0(:)
real*8 d,d1
integer i,j,k,istate,nstate,n,ibe,nbe
cm_mev=0.12398           ! cm-1 -> meV
cf1=-17.276              ! E[meV] / mu_B
cfemu= 5585./34.63       ! van Vleck mu_B/T -> 10-4 emu/Oe.cm^3
read(5,*)nbe,nstate,ndir,ipr
! nbe: number of Bext, nstate: number of eigenstates
! ndir: number of directions 
n=3    ! quadratic regression - 3 parameters
allocate (e(nbe,nstate),be(nbe),b(n),a(n,n),a1(n,n,n))
allocate (xregr(3,nstate),g(ndir,nstate),vv(ndir,nstate))
allocate (e0(nstate),gt(ndir,nstate),vt(ndir,nstate))
allocate (sigsquare(nstate),alphag(nstate),alphav(nstate))
do idir=1,ndir
 if(ipr.gt.0)write(6,*) ' direction     B [T]       E_i [meV]    iB     state'
 do istate=1,nstate
  do ibe=1,nbe
   read(26+idir,*)be(ibe),e(ibe,istate)
   if(ipr.gt.0) &
   write(6,100)idir,be(ibe),e(ibe,istate),ibe,istate
  enddo
 enddo
 write(6,*)
!  quadratic regression
 do istate=1,nstate
  do i=1,n
   b(i)=0.
   do j=1,n
    a(i,j)=0.
   enddo
  enddo
  do i=1,n
   do ibe=1,nbe
    b(i)=b(i)+be(ibe)**(i-1)*e(ibe,istate)          ! lin regr. vector
   enddo
   do j=1,n
    do ibe=1,nbe
     a(i,j)=a(i,j)+be(ibe)**(i-1)*be(ibe)**(j-1)    ! lin. regr. matrix
    enddo
   enddo
  enddo
  if(ipr.gt.1)then
   write(6,*)' right site vector B'
   write(6,101)istate,nbe
   write(6,102)(b(i),i=1,n)
   write(6,*)' matrix A of system'
   do i=1,n
    write(6,102)(a(i,j),j=1,n)
   enddo
  endif
  call detn(d,n,a)
  do i=1,n
   do j=1,n
    do k=1,n
     if(k.eq.j)then
      a1(i,j,k)=b(i)
     else
      a1(i,j,k)=a(i,j)
     endif
    enddo
   enddo 
  enddo
  do k=1,n
   if(ipr.gt.1)write(6,*)
   do i=1,n
    if(ipr.gt.1)write(6,102)(a1(i,j,k),j=1,n)
    do j=1,n
     a(i,j)=a1(i,j,k)
    enddo
   enddo
   call detn(d1,n,a)
   b(k)=d1/d
  enddo
  do i=1,n
   xregr(i,istate)=b(i)   ! solution of regresion
  enddo
   e0(istate)=xregr(1,istate)  ! xregr(1,istate) may be negative
   g(idir,istate)=2.*cf1*xregr(2,istate)
   vv(idir,istate)=2.*cf1*xregr(3,istate)
  if(ipr.gt.1)write(6,103)istate,(b(i),i=1,n)
 enddo                   ! end states
 write(6,109)idir
 109 format(' accuracy of regression for Bext || dir.',i2,', Ei=x0 + x1*B + x2*B^2')
 write(6,*)  &
  ' state   mean deviation           x0                x1                x2'
 stot=0.
 do istate =1,nstate
  sigma=0.
  if(ipr.gt.1)write(6,*) &
  ' dir. state   Bext          Eregr           Ecalc             sigma'
  write(9,*) &
  ' dir. state   Bext          Eregr           Ecalc             sigma'
  do ibe=1,nbe
   ecalc=xregr(1,istate)+xregr(2,istate)*be(ibe)+xregr(3,istate)*be(ibe)**2
   sigma=sigma+(e(ibe,istate)-ecalc)**2
   if(ipr.gt.1) &
    write(6,106)idir,istate,be(ibe),ecalc,e(ibe,istate),sigma
   write(9,106)idir,istate,be(ibe),ecalc,e(ibe,istate),sigma
  enddo
  sigsquare(istate)=sqrt(sigma/nbe)
  write(6,107)istate,sigma,(xregr(j,istate),j=1,3)
  stot=stot+sigma
 enddo
 stot=stot/nstate
 write(6,108)stot
enddo
 write(6,*)
 write(6,*)' E(B)=E0 + g muB B/2 - chi B*B/2'
 write(6,*)
 if(ndir.eq.1)then
  write(6,*)' state     E(B=0),meV      G'
 else if(ndir.eq.2)then
  write(6,*)' state     E(B=0),meV      G1         G2'
 else if(ndir.eq.3)then
  write(6,*)' state     E(B=0),meV      G1         G2          G3'
 else if(ndir.eq.4)then
  write(6,*)' state     E(B=0),meV      G1         G2          G3         G4  '
 endif
 do istate=1,nstate
  write(6,104)istate,e(1,istate),(g(idir,istate),idir=1,ndir)
  write(36,111)istate,e(1,istate),(g(idir,istate),idir=1,ndir)
  write(36,114)istate,e(1,istate),(vv(idir,istate),idir=1,ndir)
 enddo
 write(6,*)
 if(ndir.eq.1)then
  write(6,*)' state      E(B=0),meV  vV1 muB/T'
 else if(ndir.eq.2)then
  write(6,*)' state      E(B=0),meV  vV1 muB/T     vV2'
 else if(ndir.eq.3)then
  write(6,*)' state      E(B=0),meV  vV1 muB/T     vV2         vV3'
 else if(ndir.eq.4)then
  write(6,*)' state      E(B=0),meV  vV1 muB/T     vV2         vV3        vV4'
 endif
 do istate=1,nstate
  write(6,105)istate,e(1,istate),(vv(idir,istate),idir=1,ndir)
 enddo
100 format(3x,i5,4x,f9.3,f16.6,2i8)
101 format(' state',i5,', nb='i4)
102 format(7f18.4)
103 format(i6,7f18.6)
104 format(i6,f14.4,6f12.4)
105 format(i7,f14.4,6f12.6)
106 format(2i6,f8.3,3f18.6)
107 format(i6,4x,e12.4,3f18.5)
108 format(f18.6,' sum of deviations/nstate')
110 format(i6,4f11.6,f9.3)
111 format(i5,f12.3,3f10.4,3f11.6)
112 format(i6,4f9.4,f9.3)
114 format(i5,f12.3,3f11.6)
stop
end

subroutine detn(d,n,a)
real*8 a(n,n),d
d=a(1,1)*(a(2,2)*a(3,3)-a(2,3)*a(3,2)) - &
  a(1,2)*(a(2,1)*a(3,3)-a(2,3)*a(3,1)) + &
  a(1,3)*(a(2,1)*a(3,2)-a(2,2)*a(3,1))
return
end

