program regr
implicit real*8(a-h,o-z)
! polynomial regression
! present version is for quadratic regression  n=3
! e is function of be given in nbe points.
! nstate different e may be treated simultaneously 
real*8,ALLOCATABLE     :: e(:,:),be(:),b(:),a(:,:),a1(:,:,:)
real*8,ALLOCATABLE     :: xregr(:,:),g(:,:),vv(:,:),sigsquare(:)
real*8,ALLOCATABLE     :: alphag(:),alphav(:),gt(:,:),vt(:,:),e0(:)
real*8 d,d1
character*5 comp(4)
integer i,j,k,istate,nstate,n,ibe,nbe
comp(1)=' a   '
comp(2)=' b   '
comp(3)=' c   '
comp(4)=' 110 '
cm_mev=0.12398           ! cm-1 -> meV
cf1=-17.276              ! E[meV] / mu_B
cfemu= 5585./34.63       ! van Vleck mu_B/T -> 10-4 emu/Oe.cm^3
read(5,*)nbe,nstate,kramers,ncomp,nab,ipr
! nbe: number of Bext, nstate: number of eigenstates
! kramers= 0 (nonkramers), =1 (kramers)
! ncomp: number of components (a, b, c, 110 etc.)
! nab: nab=1 calculate principial component of g and chi in ab plane
!      
n=3
allocate (e(nbe,nstate),be(nbe),b(n),a(n,n),a1(n,n,n))
allocate (xregr(3,nstate),g(ncomp,nstate),vv(ncomp,nstate))
allocate (e0(nstate),gt(ncomp,nstate),vt(ncomp,nstate))
allocate (sigsquare(nstate),alphag(nstate),alphav(nstate))
do icomp=1,ncomp
 if(ipr.gt.0)write(6,*) ' component     B [T]       E_i [meV]    iB     state'
 do istate=1,nstate
  do ibe=1,nbe
   read(26+icomp,*)be(ibe),e(ibe,istate)
   if(ipr.gt.0) &
   write(6,100)comp(icomp),be(ibe),e(ibe,istate),ibe,istate
  enddo
 enddo
 write(6,*)
 isig=-1      ! serves to count Kramers doublets
 kkr=0
! linear regression
 do istate=1,nstate
  do i=1,n
   b(i)=0.
   do j=1,n
    a(i,j)=0.
   enddo
  enddo
  do i=1,n
   do ibe=1,nbe
    b(i)=b(i)+be(ibe)**(i-1)*e(ibe,istate)          ! lin regr. vector
   enddo
   do j=1,n
    do ibe=1,nbe
     a(i,j)=a(i,j)+be(ibe)**(i-1)*be(ibe)**(j-1)    ! lin. regr. matrix
    enddo
   enddo
  enddo
  if(ipr.gt.1)then
   write(6,*)' right site vector B'
   write(6,101)istate,nbe
   write(6,102)(b(i),i=1,n)
   write(6,*)' matrix A of system'
   do i=1,n
    write(6,102)(a(i,j),j=1,n)
   enddo
  endif
  call detn(d,n,a)
  do i=1,n
   do j=1,n
    do k=1,n
     if(k.eq.j)then
      a1(i,j,k)=b(i)
     else
      a1(i,j,k)=a(i,j)
     endif
    enddo
   enddo 
  enddo
  do k=1,n
   if(ipr.gt.1)write(6,*)
   do i=1,n
    if(ipr.gt.1)write(6,102)(a1(i,j,k),j=1,n)
    do j=1,n
     a(i,j)=a1(i,j,k)
    enddo
   enddo
   call detn(d1,n,a)
   b(k)=d1/d
  enddo
  do i=1,n
   xregr(i,istate)=b(i)   ! solution of regresion
  enddo
  if(kramers.ne.0)then    ! calculate g-factors of Kramers doublets
   if(ipr.gt.1)write(6,*)             ! levels must not cross
   if(isig.eq.1)then
    kkr=kkr+1
    e0(kkr)=(xregr(1,istate-1)+xregr(1,istate))/2.
    g(icomp,kkr)=cf1*(xregr(2,istate-1)-xregr(2,istate))
    vv(icomp,kkr)=cf1*(xregr(3,istate-1)+xregr(3,istate))/2.
!   vv(icomp,kkr)= cfemu*vv(icomp,kkr)   ! conversion to 10-4 emu/Oe.cm^3
   endif
  else if(kramers.eq.0)then             ! non Kramers
   e0(istate)=xregr(1,istate)
   g(icomp,istate)=2.*cf1*xregr(2,istate)
!  vv(icomp,istate)=-2.*cf1*xregr(3,istate)
   vv(icomp,istate)=2.*cf1*xregr(3,istate)
  endif 
  if(ipr.gt.1)write(6,103)istate,(b(i),i=1,n)
  isig=-isig             ! isig=1 for upper components of Kramers doublets
 enddo                   ! end states
 write(6,109)comp(icomp)
 109 format(' accuracy of regression for Bext ||',a5,', Ei=x0 + x1*B + x2*B^2')
 write(6,*)  &
  ' state   mean deviation           x0                x1                x2'
 stot=0.
 do istate =1,nstate
  sigma=0.
  if(ipr.gt.1)write(6,*) &
  ' comp. state   Bext          Eregr           Ecalc             sigma'
  write(9,*) &
  ' comp. state   Bext          Eregr           Ecalc             sigma'
  do ibe=1,nbe
   ecalc=xregr(1,istate)+xregr(2,istate)*be(ibe)+xregr(3,istate)*be(ibe)**2
   sigma=sigma+(e(ibe,istate)-ecalc)**2
   if(ipr.gt.1) &
   write(6,106)icomp,istate,be(ibe),ecalc,e(ibe,istate),sigma
   write(9,106)icomp,istate,be(ibe),ecalc,e(ibe,istate),sigma
  enddo
  sigsquare(istate)=sqrt(sigma/nbe)
  write(6,107)istate,sigma,(xregr(j,istate),j=1,3)
  stot=stot+sigma
 enddo
 stot=stot/nstate
 write(6,108)stot
enddo
if(kramers.eq.1)then
 write(6,*)' Kramers ion'
 write(6,*)' doublet   E(B=0),meV      ga         gb          gc        g110'
 do k=1,nstate/2
  j=2*k-1
  write(6,104)k,e0(k),(g(icomp,k),icomp=1,ncomp)
  write(36,111)k,e0(k),(g(icomp,k),icomp=1,ncomp)
  write(36,114)istate,e0(istate),(vv(icomp,istate),icomp=1,ncomp)
 enddo
 write(6,*)
 write(6,*)' doublet    E(B=0),meV  vVa muB/T     vVb         vVc        vV110'
 do k=1,nstate/2
  j=2*k-1
  write(6,105)k,e0(k),(vv(icomp,k),icomp=1,ncomp)
 enddo
else             !non Kramers
 write(6,*)
 write(6,*)' non-Kramers ion, E(B)=E0 + G muB B/2 - chi B*B/2'
 write(6,*)' large nonzero G indicates pseudodoublets or crossing'
 write(6,*)
 write(6,*)' singlet   E(B=0),meV      Ga         Gb          Gc         G110'
 do istate=1,nstate
  write(6,104)istate,e0(istate),(g(icomp,istate),icomp=1,ncomp)
  write(36,111)istate,e0(istate),(g(icomp,istate),icomp=1,ncomp)
  write(36,114)istate,e0(istate),(vv(icomp,istate),icomp=1,ncomp)
 enddo
 write(6,*)
 write(6,*)' singlet    E(B=0),meV  vVa muB/T     vVb         vVc        vV110'
 do istate=1,nstate
  write(6,105)istate,e0(istate),(vv(icomp,istate),icomp=1,ncomp)
 enddo
endif
if(nab.eq.1)then
 write(6,*)
 write(6,*)' Calculating canonical form of tensors in orthoperovskites'
 if(kramers.eq.0)then
  n=nstate
 elseif(kramers.eq.1)then
  n=nstate/2
 endif
 pi=3.141592653589793
 cf=pi/180.
do j=1,n
write(98,103)j,(g(i,j),i=1,4)
write(98,103)j,(vv(i,j),i=1,4)
enddo
write(98,*)
write(10,*)n
! call ab1(1,n,g,gt,alphag)
! call ab1(2,n,vv,vt,alphav)
 call ab(1,n,g,gt,alphag)
 call ab(2,n,vv,vt,alphav)
 write(6,*)
 write(6,*)' Principal axes'
 write(6,*)' state    gx       gy       gz    alpha(g)'
 do j=1,n
  write(6,112)j,(gt(i,j),i=1,3),alphag(j)/cf
 enddo
 write(6,*)
 write(6,*)' state   vVx         vVy         vVz     alpha(vV)'
 do j=1,n
  write(6,110)j,(vt(i,j),i=1,3),alphav(j)/cf
  write(79,111)j,e0(j),(gt(i,j),i=1,3)
  write(79,114)j,e0(j),(vt(i,j),i=1,3)
 enddo
endif
100 format(3x,a5,4x,f9.3,f16.6,2i8)
101 format(' state',i5,', nb='i4)
102 format(7f18.4)
103 format(i6,7f18.6)
104 format(i6,f14.4,6f12.4)
105 format(i7,f14.4,6f12.6)
106 format(2i6,f8.3,4f18.6)
107 format(i6,4x,e12.4,4f18.5)
108 format(f18.6,' sum of deviations/nstate')
110 format(i6,4f11.6,f9.3)
111 format(i5,f12.3,4f10.4,4f11.6)
112 format(i6,4f9.4,f9.3)
114 format(i5,f12.3,4f11.6)
stop
end

subroutine detn(d,n,a)
real*8 a(n,n),d
d=a(1,1)*(a(2,2)*a(3,3)-a(2,3)*a(3,2)) - &
  a(1,2)*(a(2,1)*a(3,3)-a(2,3)*a(3,1)) + &
  a(1,3)*(a(2,1)*a(3,2)-a(2,2)*a(3,1))
return
end

subroutine ab(n,nstate,r,t,alpha)
! finding principal axes in ab plane
! use components for chi (n=2),
!     square of components for g (n=1)
implicit real*8(a-h,o-z) 
real*8 r(4,nstate),t(4,nstate),alpha(nstate)
write(10,*)n,nstate
pi=3.141592653589793
cf=180./pi
do j=1,nstate
write(10,201)j,n,(r(k,j),k=1,4)
201 format(2i4,4f12.6)
 ta=r(1,j)
 tb=r(2,j)
 td=r(4,j)
 t(3,j)=r(3,j)
 if(n.eq.1)then      ! 'g-tensor' is not a true tensor
  tap=ta**2+tb**2
  tam=ta**2-tb**2
  td2=td**2
  if(tam.ne.0.)then
   t2=2.*(td2-0.5*tap)/tam
   alp=0.5*atan(t2)
   co2=cos(2.*alp)
   tx2=tap/2. + tam/(2.*co2)
   ty2=tap/2. - tam/(2.*co2)
  else
   alp=pi/4.  ! also if alp=-pi/4 (then x <-> y)
   tx2=td2
   ty2=tap-td2
  endif
  if(tx2.ge.0.)then
   t(1,j)=sqrt(tx2)
  else
   t(1,j)=0.
   write(6,*)j,' state, negative gx^2= ',tx2
  endif
  if(ty2.ge.0.)then
   t(2,j)=sqrt(ty2)
  else
   t(2,j)=0.
   write(6,*)j,' state, negative gy^2= ',ty2
  endif
 else              ! chi is a tensor
  d=(ta-tb)**2+4.*td**2
  t(1,j)=((ta+tb)+sqrt(d))/2.   ! eigenvalues
  t(2,j)=((ta+tb)-sqrt(d))/2.
  x1=t(1,j)-tb
  y1=td
  r1=sqrt(x1**2+y1**2)
  cf1=x1/r1
  alp=acos(cf1)
  x2=t(2,j)-tb
  y2=td
  r2=sqrt(x2**2+y2**2)
  cf2=x2/r2
  ph2=acos(cf2)
  trt=t(1,j)+t(2,j)+t(3,j) ! trace in canonical system
  trr=r(1,j)+r(2,j)+r(3,j) ! trace in orthorhombic system
  write(6,269)j,trr,trt
  write(10,269)j,trr,trt
  write(10,268)t(1,j),x1,y1,cf*alp
  write(10,268)t(2,j),x2,y2,cf*ph2
 endif
 alpha(j)=alp
enddo
269 format(' state',i5,' chivV trace Cs system',f12.6,', canonical',f12.6)
268 format(11x,3f14.6,f12.3) 
return
end

