program temp 
! temperature dependence of susceptibility and magnetic moment 
! for fixed magnetic field b in T
!  August 27. 2014. 
implicit real*8(a-h,o-z)
real*8 magt(3),chit(3),ft(3)
REAL*8,ALLOCATABLE  :: e0(:),g(:,:),chi(:,:),mag(:)
read(5,*)nstate,ncomp,nt,t0,dt,b,db
write(6,201)nstate,ncomp
201 format(' number of states=',i4,', number of components',i4)
203 format(' step for chi calculation dB=',f7.3,' T')
write(6,205)nt,t0,dt,b
write(6,203)db
205 format(' number of T',i4,', T0=',f7.3,', dT=',f7.3,', B=',f7.2,' T')
write(6,*)
allocate (e0(nstate),g(ncomp,nstate),chi(ncomp,nstate),mag(nstate))

cf1=17.276         ! E[meV] / mu_B
cft=0.08616        ! K -> meV

 do istate=1,nstate
  read(36,*)k1,emev,(g(j,istate),j=1,ncomp)    ! fort.36 is output of regr
  read(36,*)k1,emev,(chi(j,istate),j=1,ncomp)
  e0(istate)=abs(emev)/cft  ! all e0 must be nonnegative, meV -> K
 enddo
100 format(i6,f9.2,3f8.3,3f10.5)
write(6,*)
if(ncomp.eq.1)then
  write(6,*) '  T[K]     Fx      Mx      CHix     '
 elseif(ncomp.eq.2)then
  write(6,*)'  T[K]     Fx      Fy      Mx        My        CHix       CHiy'
 elseif(ncomp.eq.3)then
  write(6,*) &       
  '  T[K]     Fx      Fy     Fz      Mx        My        Mz         CHix        CHiy        CHiz'
endif
t=t0
do it=1,nt       ! loop over temperature
 do icomp=1,ncomp    ! loop over axes
  bm=b-db
  bp=b+db
  call m_t(nstate,ncomp,icomp,t,bm,e0,g,chi,tm,fm)
  call m_t(nstate,ncomp,icomp,t,b,e0,g,chi,tmag,f)
  call m_t(nstate,ncomp,icomp,t,bp,e0,g,chi,tp,fp)
  chit(icomp)=(tm-tp)/(2.*db)    ! chi as derivative of moment
  ft(icomp)=f
  magt(icomp)=abs(tmag)          ! make m positive
 enddo           ! end comp
 if(ncomp.eq.1)then
  write(6,101)t, &
   (ft(icomp),icomp=1,ncomp),(magt(icomp),icomp=1,ncomp),(chit(icomp),icomp=1,ncomp)
  write(40,101)t, &
   (ft(icomp),icomp=1,ncomp),(magt(icomp),icomp=1,ncomp),(chit(icomp),icomp=1,ncomp)
 elseif(ncomp.eq.2)then
  write(6,102)t, &
   (ft(icomp),icomp=1,ncomp),(magt(icomp),icomp=1,ncomp),(chit(icomp),icomp=1,ncomp)
  write(40,102)t, &
   (ft(icomp),icomp=1,ncomp),(magt(icomp),icomp=1,ncomp),(chit(icomp),icomp=1,ncomp)
 elseif(ncomp.eq.3)then
  write(6,103)t, &
   (ft(icomp),icomp=1,ncomp),(magt(icomp),icomp=1,ncomp),(chit(icomp),icomp=1,ncomp)
  write(40,103)t, &
   (ft(icomp),icomp=1,ncomp),(magt(icomp),icomp=1,ncomp),(chit(icomp),icomp=1,ncomp)
 elseif(ncomp.eq.4)then
  write(6,104)t, &
   (ft(icomp),icomp=1,ncomp),(magt(icomp),icomp=1,ncomp),(chit(icomp),icomp=1,ncomp)
  write(40,104)t, &
   (ft(icomp),icomp=1,ncomp),(magt(icomp),icomp=1,ncomp),(chit(icomp),icomp=1,ncomp)
 endif

 t=t+dt
enddo
101 format(f7.1,f8.2,f10.4,f12.6)
102 format(f7.1,2f8.2,2f10.5,2f12.6)
103 format(f7.1,3f8.2,3f10.5,3f12.6)
104 format(f7.1,4f8.2,4f10.5,4f12.6)
stop
end

subroutine m_t(nstate,ncomp,icomp,t,b,e0,g,chi,tmag,f)
implicit real*8(a-h,o-z)
real*8 e0(nstate),g(ncomp,nstate),chi(ncomp,nstate),mag
cf1=17.276         ! E[meV] / mu_B
cft=0.08616        ! K -> meV
  z=0.          ! sum of states
  tmag=0.       ! M(T)
  do istate = 1,nstate
   gi=g(icomp,istate)
   chii=chi(icomp,istate)
   emag=(gi*b - chii*b**2)/(2.*cf1)         ! Emagnetic in meV
   emag=emag/cft                              ! Emagnetic in K
   e=e0(istate) + emag
   mag=gi/2.-chii*b
   pop=exp(-e/t)
   z=z+pop
   tmag=tmag+pop*mag
  enddo                           ! end nstate
  f=-cft*t*dlog(z)    ! free energy in meV
  tmag=tmag/z
return
end
